/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *                                           *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "main.h"
#include "mojedit.h"
#include "mojlabel.h"
#include "historia.h"
#include "menu.h"

char *daneh;  //wskaznik do danych 
int pozh;  //pozycja w danych
int pozk;  //ostatni znak w buforze
int wskSkok;  //skaznik czy program jest w procedurze skok

int hx,hy;
int nrZnacznik =1;


#define MAXH     30000       //maksymalna ilosc danych 

void xypole(HWND hwnd);
void xyedit(HWND hwnd);
char znajdzOstatnioPole(int x1, int y1);

void initHistoria(void) 
{
      if (( daneh =(char*)malloc(MAXH * sizeof(char))) == NULL)
       {
        MessageBox(hwndokno,"za mao pamieci, bd funkcji malloc","Bd",MB_OK);
        exit(1);
       }
 
zerujHistoria();

}
//--------------------------------------
void zerujHistoria(void)
{
 pozh =0;
 pozk =0;
 nrZnacznik =1;
 wskSkok =0;
}
//--------------------------------------

void posprzatajHistoria(void)
{
  free((void*)daneh);
}
//--------------------------------------
void dodajHistoria(HWND hwnd,int ro, int pozycja, char znak)
{
  if (pozh > (MAXH - 5))
  {
   MessageBox(hwndokno,"Bufor od historii zapeniony","Bd",MB_OK);
  }
  else
  {
   if (ro == 0) xypole(hwnd);     //pole
   
   if ((ro == 1) || (ro == 2))    //edit
   {
     xyedit(hwnd);
     if (ro == 1){ hx +=10; hy +=10;}
     if (ro == 2){ hx +=20; hy +=20;}
   }
  
   if (ro == 255)      //znacznik
   {
     hx =100;
     hy =100;
   }
 


  
   daneh[pozh] = (char)hx;      pozh++; 
   daneh[pozh] = (char)hy;      pozh++;
   daneh[pozh] = (char)pozycja; pozh++;
   daneh[pozh] = (char)znak;    pozh++;
   pozk = pozh;
  }
}
//--------------------------------------
void xypole(HWND hwnd)
{
  int x,y;
  
        	    for (y=1 ; y < 10; y++){
                  for (x=1 ; x<10; x++){
                   if (tablabel[x][y] == hwnd)
                    {
                       hx=x, hy =y; 
                       y=10;        
                      break;
                    } 
                   }
                  }      
}
//--------------------------------------
void xyedit(HWND hwnd)
{
  int x,y;
  
        	    for (y=1 ; y < 10; y++){
                  for (x=1 ; x<10; x++){
                   if (tabedit[x][y] == hwnd)
                    {
                       hx=x, hy =y; 
                       y=10;        
                      break;
                    } 
                   }
                  }      
}
//--------------------------------------
void DoTyluHistoria (void)
{
int x,y,pozycja;
char znak;
  RECT         rect;
  char *nap;
  int i,d;  
//char B1[300];

  
for (;;)

{
  if (pozh < 4)
  {
   MessageBox(hwndokno,"Pocztek historii","Uwaga",MB_OK);
   return;
  }
  else
  {
   
   pozh--; znak = daneh[pozh];
   pozh--; pozycja = daneh[pozh];
   pozh--; y = daneh[pozh];
   pozh--; x = daneh[pozh];


   brakFokusuEdit();
   
   if (x== 100)
   {
    if(wskSkok ==0)
     {
      continue;    //jeli znacznik pobierz nastpn pozycje
     }
     else
     {
      return;
     }
   } 
   
   if (x < 10)  //dane dla pola
   {
    znak = znajdzOstatnioPole(x,y);
   
    naplabel[x][y] = znak;
    GetClientRect(tablabel[x][y],&rect);
    InvalidateRect(tablabel[x][y],&rect,TRUE);   //namaluj od nowa okienko
    return;
   }
   
   if (x < 20)  //dane dla edit  (10-20) wstawienie znaku
   {
   
    x -=10;
    y -=10;
    nap = napedit[x][y];
    d = strlen(nap);
    
         for (i=pozycja; i < d;i++)
              nap[i] = nap[i +1];
              
     nap[10] = '\0';
              
    GetClientRect(tabedit[x][y],&rect);
    InvalidateRect(tabedit[x][y],&rect,TRUE); 
    return;           
   }

   if (x < 30)  //dane dla edit  (20-30) usuwanie znaku
   {
   
    x -=20;
    y -=20;
    nap = napedit[x][y];
    d = strlen(nap);
         for (i=9; i >= pozycja;i--)
              nap[i +1] = nap[i];
    nap[pozycja] = znak;
             
    GetClientRect(tabedit[x][y],&rect);
    InvalidateRect(tabedit[x][y],&rect,TRUE); 
    return;           
   }
 
 

  }
 } //while
}
//--------------------------------------
void DoPrzoduHistoria (void)
{
 int x,y,pozycja;
 char znak;
  RECT         rect;
  char *nap;
  int i,d;

for (;;)

{
  if (pozh >= pozk)
  {
   MessageBox(hwndokno,"Koniec historii","Uwaga",MB_OK);
   return;
  }
  else
  {
    x = daneh[pozh]; pozh++;
    y = daneh[pozh]; pozh++;
    pozycja = daneh[pozh]; pozh++;
    znak = daneh[pozh]; pozh++;
   
   brakFokusuEdit();
   
   if (x== 100) 
   {
    if(wskSkok ==0)
     {
      continue;    //jeli znacznik pobierz nastpn pozycje
     }
     else
     {
      return;
     }
   } 

   if (x < 10)  //dane dla pola
   {
    naplabel[x][y] = znak;
    GetClientRect(tablabel[x][y],&rect);
    InvalidateRect(tablabel[x][y],&rect,TRUE);   
    return;
   }
   
   if (x < 20)  //dane dla edit  (10-20) wstawienie znaku
   {
    x -=10;
    y -=10;
    nap = napedit[x][y];
         for (i=9; i >= pozycja;i--)
              nap[i +1] = nap[i];
    nap[pozycja] = znak;
    GetClientRect(tabedit[x][y],&rect);
    InvalidateRect(tabedit[x][y],&rect,TRUE); 
    return;
   }
  
   if (x < 30)  //dane dla edit  (20-30) usuwanie znaku
   {
    x -=20;
    y -=20;
    nap = napedit[x][y];
     d = strlen(nap);
         for (i=pozycja; i < d;i++)
              nap[i] = nap[i +1];
              
     nap[10] = '\0';
    
    
    GetClientRect(tabedit[x][y],&rect);
    InvalidateRect(tabedit[x][y],&rect,TRUE); 
    return;
   }
   
   
  }
 }  //while

}
     
//--------------------------------------
char znajdzOstatnioPole(int x1, int y1)
{
 int x,y,pozycja;
 char znak;
 int p;
 char z1;

 p = pozh;
 z1 = ' ';  
 
 
  while (p > 3)
  {
   p--; znak = daneh[p];
   p--; pozycja = daneh[p];
   p--; y = daneh[p];
   p--; x = daneh[p];
   
  if ((x1 == x) && (y1 == y))
   {
     z1 = znak; 
     break;
   }
 }

 return z1;
}
//--------------------------------------
BOOL FileHistoria (FILE  *file )
{
 char Buffer[11 * sizeof(char)];

    if (6 != (int) fread  (&Buffer[0], 1, 6, file))
   {
     return FALSE ;
   }
    
   Buffer[6]= '\0'; 
   pozh = atoi(&Buffer[0]);
    
    
 while (pozk < (MAXH - 5))
 { 
    if (4 != (int) fread  (&Buffer[0], 1, 4, file))
   {
    
     return TRUE ;
   }
  
   daneh[pozk] = Buffer[0]; pozk++;
   daneh[pozk] = Buffer[1]; pozk++;
   daneh[pozk] = Buffer[2]; pozk++;
   daneh[pozk] = Buffer[3]; pozk++;
   
   if (Buffer[0] == 100) nrZnacznik++;
 }
 
 
return TRUE ;

}
//--------------------------
BOOL ProcDialogHistoria (HWND dialog,UINT message, WPARAM wParam, LPARAM lParam)
{
char buf[50];
int i;
 int x,y,pozycja;
 char znak;

    switch (message)                
    {
         case WM_INITDIALOG :
              i =0;
              
              while (i<pozk)
              {
                  x = daneh[i]; i++;
                  y = daneh[i]; i++;
                  pozycja = daneh[i]; i++;
                  znak = daneh[i]; i++;

               wsprintf (buf, "x=%d y=%d p=%d znak=%c",x,y,pozycja,znak) ;    
               SendDlgItemMessage(dialog,ID_LISTBOX,LB_ADDSTRING ,0,(LPARAM)buf);
              
              } 
              if (pozh > 0)
              SendDlgItemMessage(dialog,ID_LISTBOX,LB_SETCURSEL ,(int)((pozh -1) / 4),(LPARAM)0);
    	       return TRUE;
         case WM_COMMAND :
                switch (LOWORD (wParam))
                {
    			case ID_OK :
						EndDialog(dialog,TRUE);
						return TRUE;
                }
          return FALSE;
         case WM_CLOSE: 
						EndDialog(dialog,TRUE);
						return TRUE;

     }
    return FALSE;
}
//--------------------------
void podgladHistoria (HWND hwnd,HINSTANCE zad1)
{
 DialogBox(zad1,"DIALOG_HP",hwnd,(DLGPROC)ProcDialogHistoria);
}
//-------------------------- 
 void wstawZnacznikHistoria (void)
 {
  if (nrZnacznik < 127)
  {
   dodajHistoria(0,255, nrZnacznik, 'Z');
   nrZnacznik++;
  }
  else
  {
     MessageBox(hwndokno,"Za duo znacznikw, max 127","Uwaga",MB_OK);
   
  } 
 }
//--------------------------
BOOL ProcDialogHistoriaSkok (HWND dialog,UINT message, WPARAM wParam, LPARAM lParam)
{
char buf[50];
int i;
 int x,y,pozycja;
 char znak;
 HWND hwndList;
 int nItem,poz; 
 

    switch (message)                
    {
         case WM_INITDIALOG :
              i =0;
              
            SetWindowText( dialog,"Skok"); 
           if (nrZnacznik > 1)
           {   
              while (i<pozk)
              {
                  x = daneh[i]; i++;
                  y = daneh[i]; i++;
                  pozycja = daneh[i]; i++;
                  znak = daneh[i]; i++;

               if (x == 100)
               {
                wsprintf (buf, "Znacznik %d",pozycja) ;    
                SendDlgItemMessage(dialog,ID_LISTBOX,LB_ADDSTRING ,0,(LPARAM)buf);
               }
              } 
            }
            else
            {
               wsprintf (buf, "Brak znacznikw") ;    
               SendDlgItemMessage(dialog,ID_LISTBOX,LB_ADDSTRING ,0,(LPARAM)buf);
            
            }  
    	       return TRUE;
    	       
    	       
         case WM_COMMAND :
                switch (LOWORD (wParam))
                {
    		    	case ID_OK :
						EndDialog(dialog,TRUE);
						return TRUE;
						
                    case ID_LISTBOX: 
                     switch (HIWORD(wParam))
                     { 						
                      case LBN_SELCHANGE: 
                        if (nrZnacznik > 1)
                        {   
      			    	hwndList = GetDlgItem(dialog,ID_LISTBOX); 
                        nItem = SendMessage(hwndList, LB_GETCURSEL,0,0); 
                         i=0; poz=0;
                         nItem++;
                         
                         
              while ((i<pozk) && (nItem != poz ))
              {
                  x = daneh[i]; i++;
                  y = daneh[i]; i++;
                  pozycja = daneh[i]; i++;
                  znak = daneh[i]; i++;

               if (x == 100) poz++;
              } 
                         
                   
               if (pozh == i) return TRUE;
               
               wskSkok =1;
               
               if (pozh > i)
                {
                  while (pozh > i)
                  {
                    DoTyluHistoria ();
                  }
                  if (pozh < i) DoPrzoduHistoria ();
                  wskSkok =0;
                  return TRUE;
                }
                
               if (pozh < i)
                {
                  while (pozh < i)
                  {
                    DoPrzoduHistoria ();
                  }
                  if (pozh > i) DoTyluHistoria ();
                  wskSkok =0;
                  return TRUE;
                }
                 wskSkok =0;                                                                                      
                         }
                       return TRUE; 
                    } 
                    break; 
					
						
						
                }
               return FALSE;
         case WM_CLOSE: 
						EndDialog(dialog,TRUE);
						return TRUE;

     }
    return FALSE;
}
//--------------------------

void skokHistoria (HWND hwnd,HINSTANCE zad1)
{
 DialogBox(zad1,"DIALOG_HP",hwnd,(DLGPROC)ProcDialogHistoriaSkok);
}
//-------------------------- 
          
               


