/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *                                           *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <commdlg.h>
#include <string.h>

#include "plansza.h"

PRINTDLG pd ;

 
BOOL PopPrntPrintFile (HINSTANCE hInst, HWND hwnd)
{
 static DOCINFO  di = { sizeof (DOCINFO), "sudoku", NULL } ;
 BOOL            bSuccess ;
 WORD            iColCopy;
 
 
     pd.lStructSize         = sizeof (PRINTDLG) ;
     pd.hwndOwner           = hwnd ;
     pd.hDevMode            = NULL ;
     pd.hDevNames           = NULL ;
     pd.hDC                 = NULL ;
     pd.Flags               = PD_ALLPAGES | PD_COLLATE | PD_RETURNDC ;
     pd.nFromPage           = 0 ;
     pd.nToPage             = 0 ;
     pd.nMinPage            = 0 ;
     pd.nMaxPage            = 0 ;
     pd.nCopies             = 1 ;
     pd.hInstance           = NULL ;
     pd.lCustData           = 0L ;
     pd.lpfnPrintHook       = NULL ;
     pd.lpfnSetupHook       = NULL ;
     pd.lpPrintTemplateName = NULL ;
     pd.lpSetupTemplateName = NULL ;
     pd.hPrintTemplate      = NULL ;
     pd.hSetupTemplate      = NULL ;
     
     if (!PrintDlg (&pd))
          return TRUE ;

     bSuccess   = TRUE ;
						

     if (StartDoc (pd.hDC, &di) > 0)
          {
          for (iColCopy = 0 ;
               iColCopy < ((WORD) pd.Flags & PD_COLLATE ? pd.nCopies : 1) ;
               iColCopy++)
               {
                         if (StartPage (pd.hDC) < 0)
                              {
                              bSuccess = FALSE ;
                              break ;
                              }
                              
 
                              PageDrukuj (pd.hDC);
 
     
                         if (EndPage (pd.hDC) < 0)
                              {
                              bSuccess = FALSE ;
                              break ;
                              }
          
          
               } //for
          } //if
     else
          bSuccess = FALSE ;
          
     if (bSuccess)
          EndDoc (pd.hDC) ;
  
    DeleteDC (pd.hDC) ;
 
     return bSuccess  ;
}

