/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *                                           *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "main.h"
#include "kontrolki.h"
#include "mojedit.h"

char szClassEdit[ ] = "mojedit";
 WNDCLASSEX wincledit;   
 
static HBRUSH   hBrushEdit =0;
 COLORREF Edittlo;     //kolor ta label
 HFONT   hfontText1=0;

 
 HWND tabedit[10][10];  //tablica kontrolek edit
 char *napedit[10][10];  //zawartosc znaku na polu edit

 HWND editfokus = 0;
 int xPos= -1;       //pozycja klikniecia myszki    
 int pk= 0;          //pozycja kursora 

 LRESULT CALLBACK WindowProcedureEdit (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
 char* znajdzNapis(HWND hwnd);

 int editclassa(void)
 {
  int x,y;
  char *n;
  
    wincledit.hInstance = zadanie;
    wincledit.lpszClassName = szClassEdit;
    wincledit.lpfnWndProc = (WNDPROC) WindowProcedureEdit;      
    wincledit.style = CS_DBLCLKS | CS_GLOBALCLASS | CS_HREDRAW | CS_VREDRAW | CS_CLASSDC		;                 /* Catch double-clicks */
    wincledit.cbSize = sizeof (WNDCLASSEX);
    wincledit.hIcon = NULL;
    wincledit.hIconSm = NULL;
    wincledit.hCursor = LoadCursor (NULL, IDC_ARROW) ;
    wincledit.lpszMenuName = NULL;                 
    wincledit.cbClsExtra = 0;                      
    wincledit.cbWndExtra = 0;                        
    wincledit.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
        if (!RegisterClassEx (&wincledit))
        {
           MessageBox(hwndokno,"NIE MOG ZAREJESTROWA KLASY","Bd",MB_OK);
           return 0;
        }
      
     
        zmienKolorEdit(Oknotlo) ;
     	hfontText1 = CreateFont(11, 0, 0, 0, 700, 0, 0, 0,0, 0, 0, 0,
							FF_SWISS, "MS Sans Serif");

                     //przydzia pamici na kontrolki edit
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
      if (( napedit[x][y] =(char*)malloc(11 * sizeof(char))) == NULL)
       {
        MessageBox(hwndokno,"za mao pamieci, bd funkcji malloc","Bd",MB_OK);
        exit(1);
       }
        n = napedit[x][y];
        n[0]= '\0';

      }
     }
     
     

    return 1;     
 }
 //------------------------------------------   
LRESULT CALLBACK WindowProcedureEdit (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
     {
       PAINTSTRUCT  ps ;
       HDC          hdc ;
       RECT         rect,rc;
       char *nap;
       int d,x;
       char n[11 * sizeof(char)];
       HWND hed;
       SIZE wn;      //wielkosc napisu
       
        
     switch (iMsg)
          {
    	 case WM_KEYDOWN :
        	{
        	   nap = znajdzNapis(hwnd);
        	   d = strlen(nap);
        	 switch (wParam)
        	 {
        	  case VK_HOME : pk =0; break;
        	  case VK_END : pk =d; break;
        	  case VK_LEFT : pk = max(pk-1,0); break;
        	  case VK_RIGHT : pk = min(pk + 1, d ); break;
        	  case VK_DELETE :
        	                  if (d >0)
        	                  {
        	                   dodajHistoria(hwnd,2,pk,nap[pk]);
                               for (x=pk; x < d;x++)
                               nap[x] = nap[x+1];
                              }
                           break;
        	 
        	  }
        	  
               GetClientRect(hwnd,&rect);
               InvalidateRect(hwnd,&rect,TRUE); 
        	  
              return 0;
             }
          
    	 case WM_CHAR :
        	 {
        	
        	 
        	   nap = znajdzNapis(hwnd);
        	   d = strlen(nap);
        	  switch (wParam)
        	  {
        	  case '\b' : if ((d >0) && (pk >0))
        	               {
        	               dodajHistoria(hwnd,2,pk-1,nap[pk-1]);
                             for (x=pk-1; x < d;x++)
                              nap[x] = nap[x+1];
                              
                              pk--;
        	                }
        	               break;
               default :
                         if (d < 9)
                         {
                          dodajHistoria(hwnd,1,pk,(char)wParam);
                         
                            for (x=d; x >= pk;x--)
                              nap[x +1] = nap[x];
                       
                         
                          nap[pk] = (char)wParam;
                          d++;
                          nap[d] = '\0';
                          pk++;
                          }
                           break;
               }
                           
               GetClientRect(hwnd,&rect);
               InvalidateRect(hwnd,&rect,TRUE); 
                                              
              return 0;
             }
    	 case WM_KILLFOCUS :
        	 {
        	  if (editfokus == hwnd) { editfokus =0; }
              GetClientRect(hwnd,&rect);
              InvalidateRect(hwnd,&rect,TRUE); 
              return 0;
             }
    	 case WM_LBUTTONDOWN :
        	 {
        	  hed = editfokus;
              editfokus = hwnd;
              if (hed !=0)
              {
               GetClientRect(hed,&rect);
               InvalidateRect(hed,&rect,TRUE); 
              }
              
              xPos = LOWORD(lParam);  
                 nap = znajdzNapis(hwnd);
                 d = strlen(nap);
                 pk =0;           //zeruj pozycje
              if (d >0)
              {   
                hdc = GetDC( hwnd);
                SelectObject(hdc,hfontText1);
                GetTextExtentPoint(hdc,nap,d,&wn);
                if (xPos >= (wn.cx ))
                {
                  pk =d;
                 } 
                else
                { 
                 for (x=1 ; x<d +1; x++){   
                 GetTextExtentPoint(hdc,nap,x,&wn);
                 if (xPos < wn.cx) 
                 {        
                  pk = x -1;x =12;
                 // break;
                  }
                 }  
                 ReleaseDC( hwnd,hdc);
                } //else
               }
               
              GetClientRect(hwnd,&rect);
              InvalidateRect(hwnd,&rect,TRUE); 
              SetFocus(hwnd);
              return 0;
             }
          
          
          case WM_PAINT :
                hdc = BeginPaint (hwnd, &ps) ;
             
                GetClientRect(hwnd,&rect);
                FillRect(hdc,&rect,hBrushEdit);
                //   SetBkMode(hdc, TRANSPARENT);
                 SetBkColor(hdc,Edittlo);
                 
                 nap = znajdzNapis(hwnd);
                 d = strlen(nap);
                 strncpy(n,nap,10); 
                // strcpy(n,nap);
            /*    
                  if(editfokus == hwnd)
                  {
                    if (d > 9) 
                    {
                      d = 9;
                     }
                    
                    n[d] = '<';
                    d++;
                  }
             */      
                   
               
               if (d >0)
                { 
                SelectObject(hdc,hfontText1);
                DrawText(hdc,n,d,&rect,DT_SINGLELINE | DT_VCENTER | DT_LEFT);
                }
                
            if(editfokus == hwnd)
              {
              
               rc.left =0;
                if (d >0)
                 {
                  if (pk > d) { pk =d;}
                  GetTextExtentPoint(hdc,n,pk,&wn);
                  rc.left = wn.cx;
                 }
                 
           //   rc.left = d * cxChar;
             //     rc.left =0;
             
                rc.top = rect.top -2;
                rc.right = rc.left +1;
                rc.bottom = rect.bottom ;
                FillRect(hdc,&rc,GetStockObject(BLACK_BRUSH));
               }
                
                
                 EndPaint (hwnd, &ps) ;
               return 0 ;


          }
	 return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

     }
 //------------------------------------------
void posprzatajEdit(void)
{
 int x,y;
 
 if (hBrushEdit != 0) DeleteObject(hBrushEdit);
  if (hfontText1) DeleteObject(hfontText1);
  
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
     free((void*)napedit[x][y]);
     }
    }
     
}  

 //------------------------------------------
void zmienKolorEdit(COLORREF tlo)
{
 if (hBrushEdit != 0) DeleteObject(hBrushEdit);
  Edittlo = tlo;
  hBrushEdit = CreateSolidBrush(Edittlo);
}  

 //------------------------------------------
char* znajdzNapis(HWND hwnd)
{
  int x,y;
 
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
      if (tabedit[x][y] == hwnd)
      {
       return (napedit[x][y]);
      }
     }
    }
  return (napedit[1][1]);    //wrazie bdu
}
 //------------------------------------------
void brakFokusuEdit(void)
{
 HWND h1;
 RECT         rect;
 
 if ( editfokus != 0)
 {
  h1 = editfokus;
  editfokus = 0;
  SetFocus(hwndokno);
  GetClientRect(h1,&rect);
  InvalidateRect(h1,&rect,TRUE); 
 } 
}
 //------------------------------------------
 
 
